"use strict";
define(["jquery","jblock", "jui"] ,function($){
	var didLoad = false;
	function init(){//需要重新设计，此函数存在线程不安全问题，可能会导致函数体多次创建，被替换
		didLoad = true;
		ajaxHUD();
		initJsCallback();
		initAppDecryptionMap();
		initAppNativeMap();
		initAppErrorCode();
		initPushState();
		initEventListener();
	}
	function initIsLoaded(){
		if(!didLoad){
			$.blockUI({
				message : '<div class="loadmask-msg"><div>android do not invoke init()...</div></div>',
				css: {
					left: '45%',
					border: 'none',
					backgroundColor: 'none'
				},
				overlayCSS:  {
					backgroundColor: '#CCCCCC',
					opacity: 0.5
				},
				baseZ:20001,
			});
		}
	}
	/**
	 * 生成guid
	 */
	function newGuid(){
		return 'androidxxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) { var r = Math.random() * 16 | 0, v = c == 'x' ? r : r & 0x3 | 0x8; return v.toString(16); });
	}
	/**
	 *  表单数据转换为JSON
	 *  Example:
	 *  	form id : userForm
	 *  	var jsonData = android.serializeJson($('#userForm'));
	 */
	function serializeJson(othis) {
		var o = {};
		var valueArray = $(othis).serializeArray();
		$.each(valueArray, function() {
			if (o[this.name]) {
				if (!o[this.name].push)
					o[this.name] = [ o[this.name] ];
				o[this.name].push(this.value || '');
			} else
				o[this.name] = this.value || '';
		});
		trimJson(o);
		return o;
	};
	/**
	 * trim
	 */
	function trimJson(objJson) {
		$.each(objJson, function(key, value) {
			if (!$.isArray(value)) {
				objJson[key] = $.trim(value);
			}
		});
	}
	function handleAppErrorStatus(XMLHttpRequest, textStatus, errorThrown){
		if(XMLHttpRequest.status == 433){
			//var jsonParams = {url:app.ctx + "/thunisoft/login",};
			//openNativeActivity('partyLoginActivity', jsonParams, "_blank");
			openNativeActivity('loginChooseActivity', null, "_blank");
		}else if(XMLHttpRequest.status == 434){
		    nativeDoMemcache("offSiteLogin" , 1);//434异常为异地登录，保存该字段，H5根据该字段做处理.
		    showFloatBallText({
		        showText:"",//悬浮球上方提示语
		        targetActivity:"",//提示框跳转目标Activity
				targetUrl:"",//提示框跳转目标打开的url（可为空）
				extraParams:"",//附加参数Json串（预留）
				hideText:true
		    });//隐藏所有悬浮球显示文字
			//var jsonParams = {url:app.ctx + "/thunisoft/login",};
			//openNativeActivity('partyLoginActivity', jsonParams, "_blank");
			openNativeActivity('loginChooseActivity', null, "_blank");
		}
	}
	/**
	 * loading
	 */
	function ajaxHUD(){
		// 设置全局Ajax错误处理
		$.ajaxSetup({
			cache:false,
			timeout:15*1000,
			type:"POST",
			dataType:"json",
//			headers: { // 默认添加请求头
//		        "Author": "zzy" ,
//		        "Powered-By": "zzy"
//		    },
            
			error : function(XMLHttpRequest, textStatus, errorThrown){
				handleAppErrorStatus(XMLHttpRequest, textStatus, errorThrown);
			},
			beforeSend : function(jqXHR, settings) {
	if($('.zhezhao').length ==0 && $('article').length != 0){
					$('article').parent().append('<div class="zhezhao"><div class="zhezhao-w"><div class="mask-layer"><div class="circle"></div></div><span class="circle-te">正在加载...</span></div></div>');
				}
				$(document).unbind("ajaxComplete").bind("ajaxComplete", function () {
					$('.zhezhao').remove();
				});
				// 添加用户登录Session失效处理
				var interceptedSuccess = settings.success;
				// 如果dataType指定JSON，那么Session失效后返回HTML就会报错JSON.parse: unexpected character错误
				// 所以设置为dataTypes为×，自动匹配
				//delete settings.dataType;
				settings.dataTypes = ["*"];
				settings.success = function (data, textStatus, jqXHR) {
					if (jqXHR.responseText.indexOf("<html") > -1 && jqXHR.responseText.indexOf("</html>") > -1) {
						// 如果登录Session失效处理，刷新当前页回到登录页
						//TODO 失效了怎么做,默认重载页面	zhaozhiyu @ 20160720
						//window.location.reload();
					} else {
						if (interceptedSuccess) {
							interceptedSuccess(data, textStatus, jqXHR);
						}
					}
				};
			}
		});
		//注掉，有版本webview 不支持 zhaozhiyu @ 20160720
//		$("body").bind("ajaxSend", function() {
//			$blockUI();
//		}).bind("ajaxStop", function() {
//			$unblockUI();
//		});
	}
	function $blockUI() {
		$.blockUI({
			message : '<div class="loadmask-msg"><div>正在处理中，请稍等...</div></div>',
			css: {
				left: '45%',
				border: 'none',
				backgroundColor: 'none'
			},
			overlayCSS:  {
				backgroundColor: '#CCCCCC',
				opacity: 0.5
			},
			baseZ:20001,
		});
	}
	function $unblockUI() {
		$.unblockUI();
	}

	function showConfirmDialog(title, msg, callback, param){
		var title = title || '提示信息', msg = msg || '';
		if(msg.length==4) {
			msg = '<span style="margin-left:92px;">'+msg+'</span>';
		}
		$('<div id="dialog-message" title="' + title + '"></div>').append('<span>' + msg + '</span>').dialog({
			resizable: false,
			modal: true,
			closeText: 'hide',
			closeOnEscape: false,
			draggable: false,
			buttons: {
				'确定': function() {
					$( this ).dialog('close');
					if (callback) callback(param);
				},
				'取消': function() {
					$( this ).dialog('close');
				}
			}
		});
		$(".ui-dialog-titlebar-close").hide();
	}

	function showMsgDialog(title, msg,callback) {
		var title = title || '提示信息', msg = msg || '';
		if(msg.length==4) {
			msg = '<span style="margin-left:92px;">'+msg+'</span>';
		}
		$('<div id="dialog-message" title="' + title + '"></div>').append('<span>' + msg + '</span>').dialog({
			resizable: false,
			modal: true,
			closeText: 'hide',
			closeOnEscape: false,
			draggable: false,
			buttons: {
				'确定': function() {
					$( this ).dialog( "close" );
					if (callback) callback();
				}
			}
		});
		$(".ui-dialog-titlebar-close").hide();
	}

	function showMsgDialog(title, msg,callback,param,mydialog) {
		var title = title || '提示信息', msg = msg || '';
		if(msg.length==4) {
			msg = '<span style="margin-left:92px;">'+msg+'</span>';
		}
		$('<div id="dialog-message" title="' + title + '"></div>').append('<span>' + msg + '</span>').dialog({
			resizable: false,
			modal: true,
			closeText: 'hide',
			closeOnEscape: false,
			draggable: false,
			buttons: {
				'确定': function() {
					$( this ).dialog( "close" );
				}
			},
			close: function() {
				if (mydialog)mydialog.dialog( "close" );
				if (callback) callback(param);
			}
		});
		$(".ui-dialog-titlebar-close").hide();
	}

	function replaceAll(source,from,to) {
		while(source.indexOf(from)>=0) {
			source = source.replace(from,to);
		}
		return source;
	}

	function ajaxFileUploadForOne(inputUrl,inputData,inputFileElementId,inputElement){
		/*
			prepareing ajax file upload
			url: the url of script file handling the uploaded files
	        fileElementId: the file type of input element id and it will be the index of  $_FILES Array()
			dataType: it support json, xml
			secureuri:use secure protocol
			success: call back function when the ajax complete
			error: callback function when the ajax failed
	            */
		$.ajaxFileUpload({
				url:inputUrl,
				data:inputData,
				secureuri:false,
				fileElementId:inputFileElementId,
				dataType: 'json',
				success: function (msg, status){
					if(msg.success) {
						inputElement.val(msg.data);
						alert("upload "+status);
					}else {
						alert("文件过大或者文件类型不对");
					}
				},
				error: function (data, status, e){
					alert(e);
				}
			}
		);
	}
	/**
	 * JS调Java接口对象
	 */
	function getJsCallJava(){
		return HostApp;
	}
	/**
	 * 原生showToast
	 */
	function showNativeToast(toast, duration){
		if(!duration){
			duration = 'short';//'long'
		}
		getJsCallJava().showNativeToast(toast, duration);
	}
	/**
	 * 给原生复制 session cookie
	 */
	function setCookieForNative(url){
		getJsCallJava().setCookieForNative(url);
	}
	/**
	 * 扫描二维码
	 */
	function qRCodeCapture(callbackString){
		if(callbackString){
			getJsCallJava().qRCodeCapture(callbackString);
		}else{
			eval(callbackString+"('')");
		}
	}
	/**
	 * 原生实现返回
	 */
	function nativeDoHistoryBack(go){
		go = go==undefined ? -1 : go;
		getJsCallJava().historyBack(go);
	}
	/**
	 * decryption
	 */
	function nativeDoEncryption(decodeCode, decodeString, callbackString){
		setTimeout(function(){
			getJsCallJava().encryption(decodeCode, decodeString, callbackString);
		},500);
	}
	/**
	 * decryption
	 */
	function nativeDoDecryption(decodeCode, decodeString, callbackString){
		setTimeout(function(){
			getJsCallJava().decryption(decodeCode, decodeString, callbackString);
		},500);
	}
	/**
	 * 打开原生Activity
	 * json
	 * target: _self(继续本页打开)、_blank(关闭自己，打开新页)
	 */
	function openNativeActivity(nativeActivity, jsonParams, target){
		var stringParams = '';
		if(jsonParams){
			stringParams = JSON.stringify(jsonParams);
		}
		if(!target){
			target="_self";
		}
		putNativeActivityParams(jsonParams);
		getJsCallJava().openNativeActivity(nativeActivity, stringParams, target);
	}

	/**
	 * 封装打开activity参数到sessionStorage
	 * json
	 */
	function putNativeActivityParams(jsonParams){
		var sessionStorage = window.localStorage;
		var bankruptManagerStr = sessionStorage.getItem("bankrupt_manager");
		var bankruptManager = {};
		if (null != bankruptManagerStr && "" != bankruptManagerStr) {
			bankruptManager = JSON.parse(bankruptManagerStr);
		}
		bankruptManager["params"] = jsonParams;
		sessionStorage.setItem("bankrupt_manager", JSON.stringify(bankruptManager));
	}

	/**
	 * 获取上一个页面传进来的参数
	 * json
	 */
	function getNativeActivityParams(){
		var sessionStorage = window.localStorage;
		var bankruptManagerStr = sessionStorage.getItem("bankrupt_manager");
		var bankruptManager = JSON.parse(bankruptManagerStr);
		return bankruptManager["params"];
	}

	/**
	 * 原生开启memcache缓存
	 */
	function nativeDoMemcache(key, value){
		getJsCallJava().memcachePut(key, value);
	}
	/**
	 * 原生加载memcache缓存
	 */
	function nativeDoLoadMemcache(key, jsCallback){
		getJsCallJava().memcacheGet(key, jsCallback);
	}
	/**
	 * 原生删除memcache缓存
	 */
	function nativeDoDeleteMemcache(key){
		getJsCallJava().memcacheDelete(key);
	}
	/**
	 * 原生开启diskcache缓存
	 */
	function nativeDoDiskcache(key, value){
		getJsCallJava().diskcachePut(key, value);
	}
	/**
	 * 原生加载diskcache缓存
	 */
	function nativeDoLoadDiskcache(key, jsCallback){
		getJsCallJava().diskcacheGet(key, jsCallback);
	}
	/**
	 * 原生上传组件，uploadParams参数参见mobile-require-min的js文件app.uploadParams
	 */
	function nativeDoUpload(uploadParams){
		var stringParams = '';
		if(!uploadParams){
			return false;
		}
		if(uploadParams.zip == undefined){
			uploadParams.zip = false;
		}
		if(uploadParams.breakpoint == undefined){
			uploadParams.breakpoint = false;
		}
		if(uploadParams.filePaths == undefined || !(uploadParams.filePaths.length)){
			return false;
		}
		if(uploadParams.uploadParams == undefined){
			uploadParams.uploadParams = [];
		}
		if(uploadParams.fileParamsKey == undefined){
			return false;
		}
		if(uploadParams.uploadUrl == undefined){
			return false;
		}
		if(uploadParams.callbackParams == undefined){
			uploadParams.callbackParams = {};
		}
		if(uploadParams.callback == undefined){
			return false;
		}
		if(uploadParams.listSearchKey == undefined || uploadParams.listSearchKey == ""){
			uploadParams.listSearchKey = "nolist";
		}
		stringParams = JSON.stringify(uploadParams);
		getJsCallJava().nativeDoUpload(stringParams);
		return true;
	}
	/**
	 * 截屏
	 */
	function nativeDoWVScreenShot(filename, jsCallback){
		getJsCallJava().nativeDoWebViewScreenShot(filename, jsCallback);
	}
	/**
	 * 关闭当前浏览器tab
	 */
	function nativeDoBrowserFinish(){
		getJsCallJava().nativeDoBrowserFinish();
	}
	/**
	 * 文件存在
	 * fileType:app.fileExistType.ANY,//仔仔模式下载后打开，还是只下载提醒
		uniqueKey:""//唯一标识
		fileExt:"",//文件后缀名
		fileName:"",//文件名称
		jsCallback:"",//下载过程中回调，提供下载速度、已下载大小、下载总大小等
        callbackParams:{},//下载过程中回调参数，
	 */
	function nativeDoFileExist(jsonParams){
		var stringParams = '';
		if(!jsonParams){
			return false;
		}
		if(!jsonParams.fileType){
			jsonParams.fileType = app.fileExistType.ANY;
		}
		if(jsonParams.fileType == app.fileExistType.DOWNLOAD){
			if(!jsonParams.uniqueKey){
				return false;
			}
			if(!jsonParams.fileExt){
				return false;
			}
		}
		if(!jsonParams.fileName){
			return false;
		}
		if(!jsonParams.jsCallback){
			return false;
		}
		if(!jsonParams.callbackParams){
			jsonParams.callbackParams = {};
		}
		stringParams = JSON.stringify(jsonParams);
		getJsCallJava().nativeDoFileExist(stringParams);
	}
	/**
	 * 打开文件
	 */
	function nativeDoOpenFile(jsonParams){
		var stringParams = '';
		if(!jsonParams){
			return false;
		}
		if(!jsonParams.fileType){
			jsonParams.fileType = app.fileOpenType.ANY;
		}
		if(jsonParams.fileType == app.fileOpenType.DOWNLOAD){
			if(!jsonParams.uniqueKey){
				return false;
			}
			if(!jsonParams.fileExt){
				return false;
			}
		}
		if(!jsonParams.fileName){
			return false;
		}
		stringParams = JSON.stringify(jsonParams);
		getJsCallJava().nativeDoOpenFile(stringParams);
	}
	/**
	 * 图片浏览器
	 */
	function nativeDoPhotoSlider(jsonParams){
		jsonParams.url = app.location.href;
		var stringParams = '';
		stringParams = JSON.stringify(jsonParams);
		getJsCallJava().nativeDoPhotoSlider(stringParams);
	}
	/**
	 * 拍照
	 */
	function shootPicture(fileIdSelector, showIdSelector, callback){
		getJsCallJava().shootPicture();
	}
	/**
	 * 打开本地Asset下页面
	 */
	function openAssetsHtmlFile(assetHtml, callbackURL){
		getJsCallJava().openAssetsHtmlFile(assetHtml, callbackURL);
	}
	/**
	 * 选择本地图片
	 */
	function openChoosePicture(fileIdSelector, showIdSelector, callback){
		$(fileIdSelector).on('change',function(ev){
			var input=ev.target;
			if($(showIdSelector)){
				try {
					if (input.files && input.files[0]) {
						var file = input.files[0];
						if(file.type.match('image.*')){
							var reader = new FileReader();
							reader.onload = function (e) {
								var dataurl = e.target.result;
								$(showIdSelector).attr("src",dataurl);
								if(callback){
									callback(true);
								}
							};
							reader.readAsDataURL(file);
						}else{
							if(callback){
								callback(true, e.target.result);
							}
						}
					}
				} catch (e) {
					getJsCallJava().toast("重新选择！");
					if(callback){
						callback(false);
					}
				}
			}else{
				if(callback){
					callback(true, e.target.result);
				}
			}

		});
	}
	/**
	 * 启动下载器，开启下载任务
	 */
	function openDownloadLine(jsonParams){
		if(!jsonParams.downType){
			jsonParams.downType = app.downloadType.TO_BE_OPEN;
		}
		if(!jsonParams.fileExt){
			return false;
		}
		if(!jsonParams.fileName){
			return false;
		}
		if(!jsonParams.downUrl){
			showNativeToast('文件下载地址不存在' , 1);
			return false;
		}
		if(!jsonParams.downloadParams){
			jsonParams.downloadParams = {};
		}
		if(!jsonParams.jsCallback){
			jsonParams.jsCallback = '';
		}
		if(!jsonParams.callbackParams){
			jsonParams.callbackParams = {};
		}
		if(!jsonParams.uniqueKey){
			jsonParams.uniqueKey = '';
		}
		var jsonStringParams = JSON.stringify(jsonParams);
		getJsCallJava().openDownloadLine(jsonStringParams);
		return true;
	}
	/**
	 * android系统响应监听事件
	 */
	function nativeDoEventListener(eventType){
		getJsCallJava().nativeDoEventListener(eventType);
	}

	/**
	 * 分享信息到社交app
	 */
	function shareSocializationApp(jsonParams){
	    var shareTitle = jsonParams.title;
	    if (!shareTitle) {
	      shareTitle = "";
	    }
	    if (shareTitle.length > 50) {
	      var shareTitleTemp = shareTitle.substring(0, 50);
	      shareTitle = shareTitleTemp + "...";
	    }
	    var shareContent = jsonParams.content;
	    if (!shareContent) {
	      shareContent = "";
	    }
	    shareContent = shareContent.replace(/<\/?.+?>/g,"");
	    if (shareContent.length > 100) {
	      var shareContentTemp = shareContent.substring(0, 100);
	      shareContent = shareContentTemp + "...";
	    }
	    jsonParams["title"] = shareTitle;
	    jsonParams["content"] = shareContent;
		var stringJsonParams = JSON.stringify(jsonParams);
		getJsCallJava().shareSocializationApp(stringJsonParams);
	}
	
	/**
	 * 原生选择图片
	 */
	function nativeDoChooseFile(jsonParams){
	    var stringJsonParams = JSON.stringify(jsonParams);
		getJsCallJava().nativeDoChooseFile(stringJsonParams);
	}

	/**
	 * android系统响应监听事件
	 */
	function registNativeDoEventReceiver(jsonParams){
		if(jsonParams.type == app.EventListenersType.BackPress){
			if(!jsonParams.url){
				jsonParams.url = app.location.href;
			}
			if(jsonParams.callback){
				app.eventListeners.backPress[jsonParams.url] = jsonParams.callback;
			}
			if(jsonParams.positiveButton && jsonParams.positiveButton.click){
				app.eventListeners.backPress[jsonParams.url] = jsonParams.positiveButton.click;
			}else{
				if(!jsonParams.callback){
					console.log("add时，backPress没有设置有效的回调");
					return;
				}
			}
		}else if(jsonParams.type == app.EventListenersType.SettingPress){
			app.eventListeners.settingPress[jsonParams.url] = jsonParams.callback;
			return;
		}else if(jsonParams.type == app.EventListenersType.HtmlOnResume){//html页面resume
			app.eventListeners.htmlOnResume[jsonParams.url] = jsonParams.callback;
		}else if(jsonParams.type == app.EventListenersType.HtmlOnStop){//html页面stop
			app.eventListeners.htmlOnStop[jsonParams.url] = jsonParams.callback;
		}else if(jsonParams.type == app.EventListenersType.FileChoose){//html页面选择文件
			app.eventListeners.fileChoose[jsonParams.url] = jsonParams.callback;
		}else{
			console.log("add时，没有" + jsonParams.type + "的监听");
			return;
		}
		var jsonStringParams = JSON.stringify(jsonParams);
		getJsCallJava().registNativeDoEventReceiver(jsonStringParams);
	}
	/**
	 * 设置右上角setting的text
	 */
	function settingSetShow(show){
		getJsCallJava().settingSetShow(show);
	}
	/**
	 * 设置右上角setting的text
	 */
	function settingSetText(text, colorString, size){
		getJsCallJava().settingSetText(text, colorString, size);
	}
	/**
	 * 设置右上角setting的背景
	 */
	function settingSetBG(bgStr){
		getJsCallJava().settingSetBG(bgStr);
	}
	/**
	 * 设置title的显隐
	 */
	function titleSetShow(show){
		if(show){//显示

		}else{//隐藏使用空实现
			getJsCallJava().titleSetText("", "#ffffff", 16);
		}
	}
	/**
	 * 设置title的文字
	 */
	function titleSetText(text, colorString, size){
		getJsCallJava().titleSetText(text, colorString, size);
	}
	/**
	 * 设置 返回 文字
	 */
	function homeSetText(text, colorString, size){
		getJsCallJava().homeSetText(text, colorString, size);
	}
	/**
	 * 设置返回图标
	 */
	function homeSetIcon(show){
		getJsCallJava().homeSetIcon(show?true:false);
	}
	/**
	 * 设置logo图标
	 */
	function homeSetLogo(show){
		getJsCallJava().homeSetLogo(show?true:false);
	}
	/**
	 * 强制检测版本更新，并且即使用户忽略了该版本也会弹出对话框提示更新。
	 */
	function forceUpdate(callback){
		getJsCallJava().forceUpdate(callback);
	}

	/**
	 * 获取app版本号
	 */
	function getVersionName(callback){
		getJsCallJava().packageInfo(callback);
	}

	/**
	 * 数据类型判断工具类库
	 */
	function TypeUtils(){
		var typeJs = {};
		typeJs.type = function(v){
	        return Object.prototype.toString.call(v);
	    };
	    /**
	     * 是否为数组对象类型  如果是就返回true 如果不是就返回false
	     * @namespace xjo.type
	     * @method isArray
	     * @param {Any} v 被检测的变量
	     * @return {Boolean} 结果
	     */
	    typeJs.isArray = function(v){
	        return typeJs.type(v) === '[object Array]';
	    };
	    return typeJs;
	}
	/**
	 * 初始化原生回调js的string
	 */
	function initJsCallback(){
		app.jsCallback = {"jquery":$};
	}
	/**
	 * 初始化原生支持的解密
	 */
	function initAppDecryptionMap(){
		app.decryptionMap = {BASE64:"base64"};
	}
	/**
	 * 初始化原生码
	 */
	function initAppNativeMap(){
		app.nativeMap = {NATIVE_LOGIN_ACTIVITY:"loginChooseActivity", NATIVE_PORTAL_ACTIVITY:"portalActivity", NATIVE_MAIN_ACTIVITY:"mainActivity", NATIVE_WEBAPP_ACTIVITY:"webappActivity", NATIVE_APPEAL_ARGUE_ACTIVITY:"appealArgueActivity"};
	}
	/**
	 * 初始化共同处理的错误码
	 */
	function initAppErrorCode(array){
		app.errorCodeMap = {ERROR_CODE_LOGIN_FAILURE:"E2SP0101", ERROR_CODE_LOGIN_SESSION_VALID:"E2SP0109"};
		if(!array){
			app.errorCode = [app.errorCodeMap.ERROR_CODE_LOGIN_FAILURE, app.errorCodeMap.ERROR_CODE_LOGIN_SESSION_VALID];
		}else if(TypeUtils().isArray(array)){
			app.errorCode = array;
		}
	}
	/**
	 * 共通处理错误码
	 */
	function handleAppErrorCode(errorCode, callback){
		Array.prototype.S = String.fromCharCode(2);
		Array.prototype.in_array = function(e){
		var r = new RegExp(this.S+e+this.S);
			return (r.test(this.S+this.join(this.S)+this.S));
		};
		if(app.errorCode.in_array(errorCode)){
			if(callback){
				var goOn = callback(errorCode);
				if(!goOn){//如果回调返回true，则不需要处理，返回false则需要默认处理
					if(errorCode == app.errorCodeMap.ERROR_CODE_LOGIN_SESSION_VALID){
						openNativeActivity(app.nativeMap.NATIVE_LOGIN_ACTIVITY,"");
					}
				}
			}else{
				if(errorCode ==  app.errorCodeMap.ERROR_CODE_LOGIN_SESSION_VALID){
					openNativeActivity(app.nativeMap.NATIVE_LOGIN_ACTIVITY,"");
				}
			}
			return true;
		}else{
			return false;
		}
	}
	/**
	 * 初始化pushState
	 */
	function initPushState(){
		/**
		 * container为selector的规则比如 (#id)、(.class)等
		 */
		var pushStateable = true;//在加载了section后判断是否符合pushState原则：出现重复的section，规避代码不规范出现的多次点击和同名section
		app.pagerStartPopState(); //window.addEventListener("popstate")
		app.createPager = function(container){
			var stateSettings = app.stateSettings;
			stateSettings.container = container;//容器缓存起来
			app.stateSettingsParam(app.location.href, stateSettings);//本地全局变量中存储一份
			app.sessionStorage(app.location.href, stateSettings.data);//sessionStorage中存储一份页面pager间传参
		};
		app.pager = function(container, pagerSettings){
			if(pagerSettings == undefined){
				pagerSettings = app.stateSettings;
			}else{
				//TODO 过滤pagerSettings的字段待定
			}
			var pageUrl = pagerSettings.pageUrl;
			var state = app.getStateObj();
			state.type = "pager";
			if($(container).length>0){
				$.ajax({
					async:false,
					url:pageUrl,
					headers:{
						"Pager-Router" : "pager"//配合后台拦截器
					},
					success : function(responseText){
						app.pagerPushPage(container, responseText);
						//缓存跳转页面传参
						pagerSettings.container = container;//容器缓存起来
						pushState(state, pagerSettings);
						if(pagerSettings.success){
							pagerSettings.success(responseText, pagerSettings);
						}
					},
					error:function(XMLHttpRequest, textStatus, errorThrown){
						handleAppErrorStatus(XMLHttpRequest, textStatus, errorThrown);
						if(pagerSettings.error){
							pagerSettings.error(responseText, pagerSettings);
						}
					}
				});
			}else{
				if(pagerSettings.error){
					pagerSettings.error("Can't find the container error", pagerSettings);
				}else{
					console.log("Can't find the container error", pagerSettings);
				}
			}
		};
		function pushState(state, stateSettings){//stateSettings = pagerSettings || routerSettings;
			if(!pushStateable){//不符合入栈pushState，则返回
				return;
			}
			var url = stateSettings.pageUrl;
			var title = stateSettings.title?stateSettings.title:url;
			state.url = url;
			app.stateSettingsParam(url, stateSettings);//本地全局变量中存储一份，即pagerSettings
			app.pagerRequestParams(url, stateSettings.data);//sessionStorage中存储一份页面pager间传参
			if(app.eventListeners.htmlOnStop[app.location.href]){//页面被覆盖前走htmlOnStop
				app.eventListeners.htmlOnStop[app.location.href]();
			}
			if(stateSettings.pushState){//使用pushState处理
				window.history.pushState(state, title, url);//640Kfunction 超！The state object can be anything that can be serialized
			}else{//不使用pushState处理，采用replaceState
				window.history.replaceState(state, title, app.location.href);
			}
			if(app.eventListeners.htmlOnResume[app.location.href]){//新页面要展现了走htmlOnResume
				app.eventListeners.htmlOnResume[app.location.href]();
			}
			app.afterPager();
		}
		//加载page时动画
		app.pagerPushPage = function(container, responseText){
			$(container).last().children().css({visibility:"hidden", overflow:'hidden', height:"0px"});
			$(container).last().append(responseText);
			var $section = $(container).last().children().last();
			$section.addClass($section.attr('id')+'-zy');
			if($('.'+$section.attr('id')+'-zy').length>1){//出现重复的section，规避代码不规范出现的多次点击和同名section
				pushStateable = false;//不可压入栈pushState
				console.log("出现重复的section，不能打开新页面，见android-vX.X.X.js中app.pagerPushPage函数注释");
				$(container).last().children().last().remove();
				$(container).last().children().last().get(0).style.removeProperty('height');
				$(container).last().children().last().get(0).style.removeProperty('visibility');
				$(container).last().children().last().get(0).style.removeProperty('overflow');
			}
		};
		//弹出page时动画
		app.pagerPopPage = function(container){
			if($(container).last().children().length > 1){
				$(container).last().children().last().remove();
				$(container).last().children().last().get(0).style.removeProperty('height');
				$(container).last().children().last().get(0).style.removeProperty('visibility');
				$(container).last().children().last().get(0).style.removeProperty('overflow');
			}
		};
		//app.routerPopState();关闭router的routerPopPage事件
		app.router = function(routerSettings){
			if(routerSettings == undefined){
				routerSettings = app.stateSettings;
			}else{
				//TODO 过滤routerSettings的字段待定
			}
			var url = routerSettings.pageUrl;
			app.setRouterRequestParams(url, routerSettings.data);
			window.open(url,"_self");
		};
		app.routerPopPage = function(url){
			//TODO
		};
		app.routerPushPage = function(url){
			//TODO
		};
	}
	function initEventListener(){
		app.addEventLisenter = function(params, bubble){
			var url = app.location.href;
			if(!params.url){
				params.url = url;
			}
			if(!params.dataType){
				params.dataType='json';
			}
			if(!params.callback){
				params.callback = function(){};
			}
			registNativeDoEventReceiver(params);
		};
		app.responseEventListener = function(type){//供原生调用
			if(type == app.EventListenersType.BackPress){
				if(app.eventListeners.backPress[app.location.href]){
					app.eventListeners.backPress[app.location.href]();
				}
			}else if(type == app.EventListenersType.SettingPress){
				if(app.eventListeners.settingPress[app.location.href]){
					app.eventListeners.settingPress[app.location.href]();
				}
			}else if(type == app.EventListenersType.HtmlOnResume){
				if(app.eventListeners.htmlOnResume[app.location.href]){
					app.eventListeners.htmlOnResume[app.location.href]();
				}
			}else if(type == app.EventListenersType.HtmlOnStop){
				if(app.eventListeners.htmlOnStop[app.location.href]){
					app.eventListeners.htmlOnStop[app.location.href]();
				}
			}else if(type == app.EventListenersType.FileChoose){
				if(app.eventListeners.fileChoose[app.location.href]){
					app.eventListeners.fileChoose[app.location.href](arguments[1]);
				}
			}else{
				console.log("response时，没有支持" + params.type + "的监听");
			}
		};
	}
	
	/**
	 * 调用支付宝组件,alipayParams参数参见mobile-require-min的js文件app.alipayParams
	 */

	function alipay(alipayParams){
		if(!alipayParams){
			return false;
		}
		if(alipayParams.alipayAim == undefined){
			return false;
		}else if(alipayParams.authInfo == undefined && alipayParams.orderInfo == undefined){
			return false;
		}
		if(alipayParams.callback == undefined){
			return false;
		}
		var stringParams = JSON.stringify(alipayParams);
		getJsCallJava().alipay(stringParams);
		return true;
	}

	/**
	* 调用原生悬浮球文字显示设置
	*/
	function showFloatBallText(textParams){
		if(!textParams){
			return false;
		}
		if(textParams.showText == undefined){
			return false;
		}
		var stringParams = JSON.stringify(textParams);
		getJsCallJava().showFloatBallText(stringParams);
		return true;
	}
	
	/**
	* 调用原生悬浮球文字显示设置
	*/
	function setFloatBall(textParams){
		if(!textParams){
			return false;
		}
		if(textParams.switchForFloatBall == undefined){
			return false;
		}
		var stringParams = JSON.stringify(textParams);
		getJsCallJava().setFloatBall(stringParams);
		return true;
	}
	
	/**
	* 调用原生悬浮球文字显示设置
	*/
	function openOthersApp(openOthersAppParams){
		if(!openOthersAppParams){
			return false;
		}
		if(openOthersAppParams.packageName == undefined){
			return false;
		}
		var stringParams = JSON.stringify(openOthersAppParams);
		getJsCallJava().openOrDownloadOtherApp(stringParams);
		return true;
	}
	
	
	/**
	 * AMD异步模块加载Asynchronous Module Definition
	 */
	return {
		app	: app,									//来自于mobile-require-min-v2.1.11.js定义的全局变量；唯一的自定义全局变量；
		init:init,									//使用android.js必须要初始化
		/*--- JS call 原生	---*/
		alipay:alipay,                              //js调用原生支付宝sdk，包括支付宝支付和授权
		showFloatBallText:showFloatBallText,        //js调用原生悬浮球文字设置
		setFloatBall:setFloatBall,                  //js调用原生悬浮球显隐设置
		openOthersApp:openOthersApp,                //js调用原生打开其他应用
		getJsCallJava:getJsCallJava,				//得到js调android原生切口对象
		openAssetsHtmlFile:openAssetsHtmlFile,		//js调用android原生的打开asset下的html
		openChoosePicture:openChoosePicture,		//js调用android原生的拍照以及选择照片，只包含照片
		openDownloadLine:openDownloadLine,			//js调用android原生开启下载文件并打开
		openNativeActivity:openNativeActivity,		//js调用android原生的打开相应activity
		getNativeActivityParams:getNativeActivityParams, //获取 js调用打开原生activity的参数
		qRCodeCapture:qRCodeCapture,				//js调用android原生扫描二维码
		nativeDoHistoryBack:nativeDoHistoryBack,	//js调用android原生的返回操作
		nativeDoEncryption:nativeDoEncryption,		//js调用android原生的加密，建议使用只支持Base64，并且utf-8字符集
		nativeDoDecryption:nativeDoDecryption,		//js调用android原生的解密，建议使用只支持Base64，并且utf-8字符集
		nativeDoMemcache:nativeDoMemcache,			//js调用android原生开启memcache缓存，内存中随应用关闭而消失
		nativeDoLoadMemcache:nativeDoLoadMemcache,	//js调用android原生加载memcache缓存，内存中随应用关闭而消失
		nativeDoDeleteMemcache:nativeDoDeleteMemcache,//js调用android原生删除memcache缓存，内存中随应用关闭而消失
		nativeDoDiskcache:nativeDoDiskcache,		//js调用android原生开启diskcache缓存，固态应用卸而消失
		nativeDoLoadDiskcache:nativeDoLoadDiskcache,//js调用android原生加载diskcache缓存，固态应用卸而消失
		nativeDoUpload:nativeDoUpload,				//js调用android原生上传组件
		nativeDoWVScreenShot:nativeDoWVScreenShot,	//js调用android原生webview截屏
		nativeDoBrowserFinish:nativeDoBrowserFinish,//js调用android原生关闭当前浏览器
		nativeDoFileExist:nativeDoFileExist,		//js调用android原生判断文件存在
		nativeDoOpenFile:nativeDoOpenFile,			//js调用android原生打开文件
		nativeDoPhotoSlider:nativeDoPhotoSlider,	//js调用android原生打开文件
		shootPicture:shootPicture,					//js调用android原生的拍照，只有拍照
		showNativeToast:showNativeToast,			//js调原生Toast
		setCookieForNative:setCookieForNative,		//js调原生
		//nativeDoEventListener:nativeDoEventListener,//不暴露,js注册原生监控事件
		//registNativeDoEventReceiver:registNativeDoEventReceiver,//不暴露,js注册原生事件（支持返回、等）广播
		settingSetShow:settingSetShow,				//设置右上角setting显隐
		settingSetText:settingSetText,				//设置右上角setting的text
		settingSetBG:settingSetBG,					//设置右上角setting的背景图片，可系统可图片地址
		titleSetShow:titleSetShow,					//设置title的显隐
		titleSetText:titleSetText,					//设置title的文字
		homeSetText:homeSetText,					//设置 返回 文字
		homeSetIcon:homeSetIcon,					//设置返回图标
		homeSetLogo:homeSetLogo,					//设置logo图标
		forceUpdate:forceUpdate,					//强制检测版本更新，并且即使用户忽略了该版本也会弹出对话框提示更新。
		getVersionName:getVersionName,				//获取app版本
		/*---	上为原生	分割线	下为js	---*/
		$blockUI:$blockUI,							//手动调用显示加载中。。。
		ajaxFileUploadForOne:ajaxFileUploadForOne,
		ajaxHUD : ajaxHUD,							//页面抬头显示器(Head Up Display)，加载中。。。提示
		handleAppErrorCode:handleAppErrorCode,		//自定义errorcode 方式，处理统一的app错误码
		handleAppErrorStatus:handleAppErrorStatus,	//http error status 方式处理共通异常
		newGuid:newGuid,							//生成GUID
		replaceAll:replaceAll,						//工具类，替换字符，不应该出现在这里！
		serializeJson : serializeJson,				//序列化表单转成json
		showConfirmDialog:showConfirmDialog,
		showMsgDialog:showMsgDialog,
		trimJson : trimJson,						//对json对象做trim处理，serializeJson已经调用，不需要再次调用
		TypeUtils:TypeUtils,						//js类型判断工具
		shareSocializationApp : shareSocializationApp, //分享到社交app
		nativeDoChooseFile : nativeDoChooseFile //js调用android原生选择文件
	};
});
