/* ===================================================
* @Description: 基于原生bootstrap深度定制而来(移动端浏览器目前对HTML5使用 JavaScript File API还不是很好所移动端文件上传最好还是原生做)
*               基于restful接口而设计
*               ps：由于时间有限，实现的比较烂，勿将其复制到其他项目使用
*               源代码:https://github.com/kartik-v/bootstrap-fileinput
* @author yanlei
* @date 2016-7-21 上午12:41:47
 * ========================================================== */
(function (factory) {
    "use strict";
    if (typeof define === 'function' && define.amd) { // jshint ignore:line
        // AMD. Register as an anonymous module.
        define(['jquery'], factory); // jshint ignore:line
    } else { // noinspection JSUnresolvedVariable
        if (typeof module === 'object' && module.exports) { // jshint ignore:line
            // Node/CommonJS
            // noinspection JSUnresolvedVariable
            module.exports = factory(require('jquery')); // jshint ignore:line
        } else {
            // Browser globals
            factory(window.jQuery);
        }
    }
}(function ($) {
    "use strict";
    
    var Toastr = getToastr();
    Toastr.options = {
    		"closeButton" : false, // 是否显示关闭按钮
    		"debug" : false, // 是否使用debug模式
    		"positionClass" : "toast-top-full-width",// 弹出窗的位置
    		"showDuration" : "300",// 显示的动画时间
    		"hideDuration" : "1000",// 消失的动画时间
    		"timeOut" : "3000", // 展现时间
    		"extendedTimeOut" : "1000",// 加长展示时间
    		"showEasing" : "swing",// 显示时的动画缓冲方式
    		"hideEasing" : "linear",// 消失时的动画缓冲方式
    		"showMethod" : "fadeIn",// 显示时的动画方式
    		"hideMethod" : "fadeOut", // 消失时的动画方式
    		"preventDuplicates": true
    	};
	function getToastr(){
    	 var $toadstrContainer;
         var listener;
         var toastId = 0;
         var toastType = {
             error: 'error',
             info: 'info',
             success: 'success',
             warning: 'warning'
         };

         var toastr = {
             clear: clear,
             remove: remove,
             error: error,
             getContainer: getContainer,
             info: info,
             options: {},
             subscribe: subscribe,
             success: success,
             version: '2.1.2',
             warning: warning
         };

         var previousToast;

         return toastr;

         ////////////////

         function error(message, title, optionsOverride) {
             return notify({
                 type: toastType.error,
                 iconClass: getOptions().iconClasses.error,
                 message: message,
                 optionsOverride: optionsOverride,
                 title: title
             });
         }

         function getContainer(options, create) {
             if (!options) { options = getOptions(); }
             $toadstrContainer = $('#' + options.containerId);
             if ($toadstrContainer.length) {
                 return $toadstrContainer;
             }
             if (create) {
                 $toadstrContainer = createContainer(options);
             }
             return $toadstrContainer;
         }

         function info(message, title, optionsOverride) {
             return notify({
                 type: toastType.info,
                 iconClass: getOptions().iconClasses.info,
                 message: message,
                 optionsOverride: optionsOverride,
                 title: title
             });
         }

         function subscribe(callback) {
             listener = callback;
         }

         function success(message, title, optionsOverride) {
             return notify({
                 type: toastType.success,
                 iconClass: getOptions().iconClasses.success,
                 message: message,
                 optionsOverride: optionsOverride,
                 title: title
             });
         }

         function warning(message, title, optionsOverride) {
             return notify({
                 type: toastType.warning,
                 iconClass: getOptions().iconClasses.warning,
                 message: message,
                 optionsOverride: optionsOverride,
                 title: title
             });
         }

         function clear($toastElement, clearOptions) {
             var options = getOptions();
             if (!$toadstrContainer) { getContainer(options); }
             if (!clearToast($toastElement, options, clearOptions)) {
                 clearContainer(options);
             }
         }

         function remove($toastElement) {
             var options = getOptions();
             if (!$toadstrContainer) { getContainer(options); }
             if ($toastElement && $(':focus', $toastElement).length === 0) {
                 removeToast($toastElement);
                 return;
             }
             if ($toadstrContainer.children().length) {
                 $toadstrContainer.remove();
             }
         }

         // internal functions

         function clearContainer (options) {
             var toastsToClear = $toadstrContainer.children();
             for (var i = toastsToClear.length - 1; i >= 0; i--) {
                 clearToast($(toastsToClear[i]), options);
             }
         }

         function clearToast ($toastElement, options, clearOptions) {
             var force = clearOptions && clearOptions.force ? clearOptions.force : false;
             if ($toastElement && (force || $(':focus', $toastElement).length === 0)) {
                 $toastElement[options.hideMethod]({
                     duration: options.hideDuration,
                     easing: options.hideEasing,
                     complete: function () { removeToast($toastElement); }
                 });
                 return true;
             }
             return false;
         }

         function createContainer(options) {
             $toadstrContainer = $('<div/>')
                 .attr('id', options.containerId)
                 .addClass(options.positionClass)
                 .attr('aria-live', 'polite')
                 .attr('role', 'alert');

             $toadstrContainer.appendTo($(options.target));
             return $toadstrContainer;
         }

         function getDefaults() {
             return {
                 tapToDismiss: true,
                 toastClass: 'toast',
                 containerId: 'toast-container',
                 debug: false,

                 showMethod: 'fadeIn', //fadeIn, slideDown, and show are built into jQuery
                 showDuration: 300,
                 showEasing: 'swing', //swing and linear are built into jQuery
                 onShown: undefined,
                 hideMethod: 'fadeOut',
                 hideDuration: 1000,
                 hideEasing: 'swing',
                 onHidden: undefined,
                 closeMethod: false,
                 closeDuration: false,
                 closeEasing: false,

                 extendedTimeOut: 1000,
                 iconClasses: {
                     error: 'toast-error',
                     info: 'toast-info',
                     success: 'toast-success',
                     warning: 'toast-warning'
                 },
                 iconClass: 'toast-info',
                 positionClass: 'toast-top-right',
                 timeOut: 5000, // Set timeOut and extendedTimeOut to 0 to make it sticky
                 titleClass: 'toast-title',
                 messageClass: 'toast-message',
                 escapeHtml: false,
                 target: 'body',
                 closeHtml: '<button type="button">&times;</button>',
                 newestOnTop: true,
                 preventDuplicates: false,
                 progressBar: false
             };
         }

         function publish(args) {
             if (!listener) { return; }
             listener(args);
         }

         function notify(map) {
             var options = getOptions();
             var iconClass = map.iconClass || options.iconClass;

             if (typeof (map.optionsOverride) !== 'undefined') {
                 options = $.extend(options, map.optionsOverride);
                 iconClass = map.optionsOverride.iconClass || iconClass;
             }

             if (shouldExit(options, map)) { return; }

             toastId++;

             $toadstrContainer = getContainer(options, true);

             var intervalId = null;
             var $toastElement = $('<div/>');
             var $titleElement = $('<div/>');
             var $messageElement = $('<div/>');
             var $progressElement = $('<div/>');
             var $closeElement = $(options.closeHtml);
             var progressBar = {
                 intervalId: null,
                 hideEta: null,
                 maxHideTime: null
             };
             var response = {
                 toastId: toastId,
                 state: 'visible',
                 startTime: new Date(),
                 options: options,
                 map: map
             };

             personalizeToast();

             displayToast();

             handleEvents();

             publish(response);

             if (options.debug && console) {
                 console.log(response);
             }

             return $toastElement;

             function escapeHtml(source) {
                 if (source == null)
                     source = "";

                 return new String(source)
                     .replace(/&/g, '&amp;')
                     .replace(/"/g, '&quot;')
                     .replace(/'/g, '&#39;')
                     .replace(/</g, '&lt;')
                     .replace(/>/g, '&gt;');
             }

             function personalizeToast() {
                 setIcon();
                 setTitle();
                 setMessage();
                 setCloseButton();
                 setProgressBar();
                 setSequence();
             }

             function handleEvents() {
                 $toastElement.hover(stickAround, delayedHideToast);
                 if (!options.onclick && options.tapToDismiss) {
                     $toastElement.click(hideToast);
                 }

                 if (options.closeButton && $closeElement) {
                     $closeElement.click(function (event) {
                         if (event.stopPropagation) {
                             event.stopPropagation();
                         } else if (event.cancelBubble !== undefined && event.cancelBubble !== true) {
                             event.cancelBubble = true;
                         }
                         hideToast(true);
                     });
                 }

                 if (options.onclick) {
                     $toastElement.click(function (event) {
                         options.onclick(event);
                         hideToast();
                     });
                 }
             }

             function displayToast() {
                 $toastElement.hide();

                 $toastElement[options.showMethod](
                     {duration: options.showDuration, easing: options.showEasing, complete: options.onShown}
                 );

                 if (options.timeOut > 0) {
                     intervalId = setTimeout(hideToast, options.timeOut);
                     progressBar.maxHideTime = parseFloat(options.timeOut);
                     progressBar.hideEta = new Date().getTime() + progressBar.maxHideTime;
                     if (options.progressBar) {
                         progressBar.intervalId = setInterval(updateProgress, 10);
                     }
                 }
             }

             function setIcon() {
                 if (map.iconClass) {
                     $toastElement.addClass(options.toastClass).addClass(iconClass);
                 }
             }

             function setSequence() {
                 if (options.newestOnTop) {
                     $toadstrContainer.prepend($toastElement);
                 } else {
                     $toadstrContainer.append($toastElement);
                 }
             }

             function setTitle() {
                 if (map.title) {
                     $titleElement.append(!options.escapeHtml ? map.title : escapeHtml(map.title)).addClass(options.titleClass);
                     $toastElement.append($titleElement);
                 }
             }

             function setMessage() {
                 if (map.message) {
                     $messageElement.append(!options.escapeHtml ? map.message : escapeHtml(map.message)).addClass(options.messageClass);
                     $toastElement.append($messageElement);
                 }
             }

             function setCloseButton() {
                 if (options.closeButton) {
                     $closeElement.addClass('toast-close-button').attr('role', 'button');
                     $toastElement.prepend($closeElement);
                 }
             }

             function setProgressBar() {
                 if (options.progressBar) {
                     $progressElement.addClass('toast-progress');
                     $toastElement.prepend($progressElement);
                 }
             }

             function shouldExit(options, map) {
                 if (options.preventDuplicates) {
                     if (map.message === previousToast) {
                         return true;
                     } else {
                         previousToast = map.message;
                     }
                 }
                 return false;
             }

             function hideToast(override) {
                 var method = override && options.closeMethod !== false ? options.closeMethod : options.hideMethod;
                 var duration = override && options.closeDuration !== false ?
                     options.closeDuration : options.hideDuration;
                 var easing = override && options.closeEasing !== false ? options.closeEasing : options.hideEasing;
                 if ($(':focus', $toastElement).length && !override) {
                     return;
                 }
                 clearTimeout(progressBar.intervalId);
                 return $toastElement[method]({
                     duration: duration,
                     easing: easing,
                     complete: function () {
                         removeToast($toastElement);
                         if (options.onHidden && response.state !== 'hidden') {
                             options.onHidden();
                         }
                         response.state = 'hidden';
                         response.endTime = new Date();
                         publish(response);
                     }
                 });
             }

             function delayedHideToast() {
                 if (options.timeOut > 0 || options.extendedTimeOut > 0) {
                     intervalId = setTimeout(hideToast, options.extendedTimeOut);
                     progressBar.maxHideTime = parseFloat(options.extendedTimeOut);
                     progressBar.hideEta = new Date().getTime() + progressBar.maxHideTime;
                 }
             }

             function stickAround() {
                 clearTimeout(intervalId);
                 progressBar.hideEta = 0;
                 $toastElement.stop(true, true)[options.showMethod](
                     {duration: options.showDuration, easing: options.showEasing}
                 );
             }

             function updateProgress() {
                 var percentage = ((progressBar.hideEta - (new Date().getTime())) / progressBar.maxHideTime) * 100;
                 $progressElement.width(percentage + '%');
             }
         }

         function getOptions() {
             return $.extend({}, getDefaults(), toastr.options);
         }

         function removeToast($toastElement) {
             if (!$toadstrContainer) { $toadstrContainer = getContainer(); }
             if ($toastElement.is(':visible')) {
                 return;
             }
             $toastElement.remove();
             $toastElement = null;
             if ($toadstrContainer.children().length === 0) {
                 $toadstrContainer.remove();
                 previousToast = undefined;
             }
         }
    }
    var NAMESPACE, MODAL_ID, LOADING_ID, STYLE_SETTING, OBJECT_PARAMS, DEFAULT_PREVIEW;
    var tMain, tPreview, tModalMain ,tLoadingMain, tModal, tSize, tTagBef, tTagBef1, tTagBef2, tGeneric, tHtml, tImage, tText, tVideo, tAudio, tFlash, tObject, tPdf, tOther, tLoading;
    var defaultLayoutTemplates, defaultPreviewTemplates, defaultPreviewTypes, defaultPreviewSettings, defaultPreviewZoomSettings, defaultFileTypeSettings;
    var FileInput;
    
    var NAMESPACE, objUrl, compare, handler, getNum, hasFileAPISupport, hasDragDropSupport, hasFileUploadSupport, addCss, isEmpty, getElement, isArray, ifSet, uniqId, htmlEncode, replaceTags, findFileName, checkFullScreen, toggleFullScreen;
    NAMESPACE = '.fileinput';
    objUrl = window.URL || window.webkitURL;
    compare = function(input, str, exact) {
        return input !== undefined && (exact ? input === str : input.match(str));
    };
    handler = function($el, event, callback, skipNS) {
        var ev = skipNS ? event : event.split(' ').join(NAMESPACE + ' ') + NAMESPACE;
        $el.off(ev).on(ev, callback);
    };
    getNum = function(num, def) {
        def = def || 0;
        if (typeof num === "number") {
            return num;
        }
        if (typeof num === "string") {
            num = parseFloat(num);
        }
        return isNaN(num) ? def : num;
    };
    hasFileAPISupport = function() {
        return !!(window.File && window.FileReader);
    };
    hasDragDropSupport = function() {
        var div = document.createElement('div');
        /** @namespace div.draggable */
        /** @namespace div.ondragstart */
        /** @namespace div.ondrop */
        return !(div.draggable !== undefined || (div.ondragstart !== undefined && div.ondrop !== undefined));
    };
    hasFileUploadSupport = function() {
        return hasFileAPISupport() && window.FormData;
    };
    addCss = function($el, css) {
        $el.removeClass(css).addClass(css);
    };
    getElement = function(options, param, value) {
        return (isEmpty(options) || isEmpty(options[param])) ? value : $(options[param]);
    };
    isEmpty = function(value, trim) {
        return value === undefined || value === null || value.length === 0 || (trim && $.trim(value) === '');
    };
    isArray = function(a) {
        return Array.isArray(a) || Object.prototype.toString.call(a) === '[object Array]';
    };
    ifSet = function(needle, haystack, def) {
        def = def || '';
        return (typeof haystack === 'object' && needle in haystack) ? haystack[needle] : def;
    };
    uniqId = function() {
        return Math.round(new Date().getTime() + (Math.random() * 100));
    };
    htmlEncode = function(str) {
        return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g,
                '&apos;');
    };
    replaceTags = function(str, tags) {
        var out = str;
        if (!tags) {
            return out;
        }
        $.each(tags, function(key, value) {
            if (typeof value === "function") {
                value = value();
            }
            out = out.split(key).join(value);
        });
        return out;
    };
    findFileName = function (filePath) {
        var sepIndex = filePath.lastIndexOf('/');
        if (sepIndex === -1) {
            sepIndex = filePath.lastIndexOf('\\');
        }
        return filePath.split(filePath.substring(sepIndex, sepIndex + 1)).pop();
    };
    var previewCache;
    previewCache = {
        data: {},
        init: function (obj) {
            var content = obj.initialPreview, id = obj.id;
            if (content.length > 0 && !isArray(content)) {
                content = content.split(obj.initialPreviewDelimiter);
            }
            previewCache.data[id] = {
                content: content,
                config: obj.initialPreviewConfig,
                tags: obj.initialPreviewThumbTags,
                delimiter: obj.initialPreviewDelimiter,
                previewFileType: obj.initialPreviewFileType,
                previewAsData: obj.initialPreviewAsData,
                template: obj.previewGenericTemplate,
                showZoom: true,
                showDrag: true,
                getSize: function(size) {
                    return obj._getSize(size);
                },
                parseTemplate: function (cat, data, fname, ftype, pId, ftr, ind, size) {
                    var fc = ' file-preview-initial';
                    return obj._generatePreviewTemplate(cat, data, fname, ftype, pId, false, null, fc, ftr, ind);
                },
                msg: function (n) {
                    return obj._getMsgSelected(n);
                },
                initId: obj.previewInitId,
                isDelete: obj.initialPreviewShowDelete,
            };
        },
        fetch: function (id) {
            return previewCache.data[id].content.filter(function (n) {
                return n !== null;
            });
        },
        count: function (id, all) {
            return !!previewCache.data[id] && !!previewCache.data[id].content ?
                (all ? previewCache.data[id].content.length : previewCache.fetch(id).length) : 0;
        },
        get: function (id, i, isDisabled) {
            var ind = 'init_' + i, data = previewCache.data[id], config = data.config[i], content = data.content[i],
                previewId = data.initId + '-' + ind, out, $tmp, frameClass = ' file-preview-initial', cat, cap, ftr,
                ftype, asData = ifSet('previewAsData', config, data.previewAsData);
            isDisabled = isDisabled === undefined ? true : isDisabled;
            /** @namespace config.frameAttr */
            /** @namespace config.frameClass */
            /** @namespace config.filetype */
            if (!content) {
                return '';
            }
            if (config && config.frameClass) {
                frameClass += ' ' + config.frameClass;
            }
            if (asData) {
                cat = data.previewAsData ? ifSet('type', config, data.previewFileType || 'generic') : 'generic';
                ftype = ifSet('filetype', config, cat);
                out = data.parseTemplate(cat, content, cap, ftype, previewId, ftr, ind, null);
            } else {
                out = data.template
                    .replace(/\{previewId}/g, previewId).replace(/\{frameClass}/g, frameClass)
                    .replace(/\{fileindex}/g, ind).replace(/\{content}/g, data.content[i])
                    .replace(/\{template}/g, ifSet('type', config, data.previewFileType))
            }
            if (data.tags.length && data.tags[i]) {
                out = replaceTags(out, data.tags[i]);
            }
            if (!isEmpty(config) && !isEmpty(config.frameAttr)) {
                $tmp = $(document.createElement('div')).html(out);
                $tmp.find('.file-preview-initial').attr(config.frameAttr);
                out = $tmp.html();
                $tmp.remove();
            }
            return out;
        },
        add: function (id, content, config, tags, append) {
            var data = $.extend(true, {}, previewCache.data[id]), index;
            if (!isArray(content)) {
                content = content.split(data.delimiter);
            }
            if (append) {
                index = data.content.push(content) - 1;
                data.config[index] = config;
                data.tags[index] = tags;
            } else {
                index = content.length - 1;
                data.content = content;
                data.config = config;
                data.tags = tags;
            }
            previewCache.data[id] = data;
            return index;
        },
        set: function (id, content, config, tags, append) {
            var data = $.extend(true, {}, previewCache.data[id]), i, chk;
            if (!content || !content.length) {
                return;
            }
            if (!isArray(content)) {
                content = content.split(data.delimiter);
            }
            chk = content.filter(function (n) {
                return n !== null;
            });
            if (!chk.length) {
                return;
            }
            if (data.content === undefined) {
                data.content = [];
            }
            if (data.config === undefined) {
                data.config = [];
            }
            if (data.tags === undefined) {
                data.tags = [];
            }
            if (append) {
                for (i = 0; i < content.length; i++) {
                    if (content[i]) {
                        data.content.push(content[i]);
                    }
                }
                for (i = 0; i < config.length; i++) {
                    if (config[i]) {
                        data.config.push(config[i]);
                    }
                }
                for (i = 0; i < tags.length; i++) {
                    if (tags[i]) {
                        data.tags.push(tags[i]);
                    }
                }
            } else {
                data.content = content;
                data.config = config;
                data.tags = tags;
            }
            previewCache.data[id] = data;
        },
        unset: function (id, index) {
            var chk = previewCache.count(id);
            if (!chk) {
                return;
            }
            if (chk === 1) {
                previewCache.data[id].content = [];
                previewCache.data[id].config = [];
                previewCache.data[id].tags = [];
                return;
            }
            previewCache.data[id].content[index] = null;
            previewCache.data[id].config[index] = null;
            previewCache.data[id].tags[index] = null;
        },
        out: function (id) {
            var html = '', data = previewCache.data[id], len = previewCache.count(id, true);
            if (len === 0) {
                return {content: ''};
            }
            for (var i = 0; i < len; i++) {
                html += previewCache.get(id, i);
            }
            return {content: '<div class="file-initial-thumbs">' + html + '</div>'};
        }
    };

    NAMESPACE = '.fileinput';
    MODAL_ID = 'kvFileinputModal';
    LOADING_ID = 'kvLoadinginputModal';
    STYLE_SETTING = 'style="width:{width};height:{height};"';
    OBJECT_PARAMS = '<param name="controller" value="true" />\n' +
        '<param name="allowScriptAccess" value="always" />\n' +
        '<param name="autoPlay" value="false" />\n' +
        '<param name="autoStart" value="false" />\n' +
        '<param name="quality" value="high" />\n';
    DEFAULT_PREVIEW = '<div class="file-preview-other">\n' +
        '</div>';
    tMain = '{preview}\n';
    tPreview = 
        '<div class="file-preview">\n' +
        '</div>';
    //noinspection HtmlUnknownAttribute
    tModalMain = '<div id="' + MODAL_ID + '" class="file-zoom-dialog modal fade file-zoom-fullscreen" tabindex="-1" aria-labelledby="' +
        MODAL_ID + 'Label"></div>';
    tLoadingMain = '<div id="' + LOADING_ID + '" class="file-zoom-dialog modal fade file-zoom-fullscreen" tabindex="-1" aria-labelledby="' +
    MODAL_ID + 'Label"></div>';
    tModal = '<div class="modal-dialog modal-lg" role="document">\n' +
        '  <div class="modal-content">\n' +
        '    <div class="modal-header">\n' +
        '      <div class="kv-zoom-actions pull-right">{remove}{close}</div>\n' +
        '      <h3 class="modal-title"><small><span class="kv-zoom-title"></span></small></h3>\n' +
        '    </div>\n' +
        '    <div class="modal-body">\n' +
        '      <div class="kv-zoom-body file-zoom-content"></div>\n' + '{prev} {next}\n' +
        '    </div>\n' +
        '  </div>\n' +
        '</div>\n';
    tLoading = '<div class="modal-dialog modal-lg" role="document">\n' +
    '  <div class="modal-content" style="background-color:rgba(0, 0, 0, 0);">\n' +
    '    <div class="modal-body">\n' +
    '      <div class="load-text" style="width: 360px;line-height:640px;"><div style="margin: 0px auto; width:100px;"><span>文件上传中.....</span></div></div>\n' + 
    '    </div>\n' +
    '  </div>\n' +
    '</div>\n';
    tSize = ' <br><samp>({sizeText})</samp>';
    tTagBef = '<div class="file-item col-xs-4 {frameClass}" id="{previewId}" data-fileindex="{fileindex}"' +
        ' data-template="{template}" data-filename="{filename}" data-remove-url="{removeUrl}"';
    tTagBef1 = tTagBef + '>\n';
    tTagBef2 = tTagBef + '' + STYLE_SETTING + '>\n';
    tGeneric = '{content}\n';
    tHtml = '<div class="kv-preview-data file-preview-html"  ' + STYLE_SETTING + '>{data}</div>\n';
    tImage = '<img src="{data}" class="kv-preview-data file-preview-image"  ' +
        STYLE_SETTING + '>\n';
    tText = '<textarea class="kv-preview-data file-preview-text" readonly ' + STYLE_SETTING +
        '>{data}</textarea>\n';
    tVideo = '<video class="kv-preview-data" width="{width}" height="{height}" controls>\n' +
        '<source src="{data}" type="{type}">\n' + DEFAULT_PREVIEW + '\n</video>\n';
    tAudio = '<audio class="kv-preview-data" controls>\n<source src="' + '{data}' + '" type="{type}">\n' +
        DEFAULT_PREVIEW + '\n</audio>\n';
    tFlash = '<object class="kv-preview-data file-object" type="application/x-shockwave-flash" ' +
        'width="{width}" height="{height}" data="{data}">\n' + OBJECT_PARAMS + ' ' + DEFAULT_PREVIEW + '\n</object>\n';
    tObject = '<object class="kv-preview-data file-object" data="{data}" type="{type}" width="{width}" height="{height}">\n' +
        '<param name="movie" />\n' + OBJECT_PARAMS + ' ' + DEFAULT_PREVIEW + '\n</object>\n';
    tPdf = '<embed class="kv-preview-data" src="{data}" width="{width}" height="{height}" type="application/pdf">\n';
    tOther = '<div class="kv-preview-data file-preview-other-frame">\n' + DEFAULT_PREVIEW + '\n</div>\n';
    defaultLayoutTemplates = {
        main: tMain,
        preview: tPreview,
        modalMain: tModalMain,
        modal: tModal,
        loadingMain : tLoadingMain,
        loading : tLoading,
        size: tSize
    };
    defaultPreviewTemplates = {
        generic: tTagBef1 + tGeneric,
        html: tTagBef1 + tHtml,
        image: tTagBef1 + tImage,
        text: tTagBef1 + tText,
        video: tTagBef2 + tVideo,
        audio: tTagBef2 + tAudio,
        flash: tTagBef2 + tFlash,
        object: tTagBef2 + tObject,
        pdf: tTagBef2 + tPdf,
        other: tTagBef2 + tOther
    };
    defaultPreviewTypes = ['image', 'html', 'text', 'video', 'audio', 'flash', 'object'];
    defaultPreviewSettings = {
        image: {width: "100%", height: "28vw"},
        html: {width: "100%", height: "28vw"},
        text: {width: "100%", height: "28vw"},
        video: {width: "100%", height: "28vw"},
        audio: {width: "100%", height: "28vw"},
        flash: {width: "100%", height: "28vw"},
        object: {width: "100%", height: "28vw"},
        pdf: {width: "100%", height: "28vw"},
        other: {width: "100%", height: "28vw"}
    };
    defaultPreviewZoomSettings = {
        image: {width: "100%", height: "100%"},
        html: {width: "100%", height: "100%", 'min-height': "480px"},
        text: {width: "100%", height: "100%", 'min-height': "480px"},
        video: {width: "auto", height: "100%", 'max-width': "100%"},
        audio: {width: "100%", height: "30px"},
        flash: {width: "auto", height: "480px"},
        object: {width: "auto", height: "480px"},
        pdf: {width: "100%", height: "100%", 'min-height': "480px"},
        other: {width: "auto", height: "100%", 'min-height': "480px"}
    };
    defaultFileTypeSettings = {
        image: function (vType, vName) {
            return compare(vType, 'image.*') || compare(vName, /\.(gif|png|jpe?g)$/i);
        },
        html: function (vType, vName) {
            return compare(vType, 'text/html') || compare(vName, /\.(htm|html)$/i);
        },
        text: function (vType, vName) {
            return compare(vType, 'text.*') || compare(vType, /\.(xml|javascript)$/i) ||
                compare(vName, /\.(txt|md|csv|nfo|ini|json|php|js|css)$/i);
        },
        video: function (vType, vName) {
            return compare(vType, 'video.*') && (compare(vType, /(ogg|mp4|mp?g|webm|3gp)$/i) ||
                compare(vName, /\.(og?|mp4|webm|mp?g|3gp)$/i));
        },
        audio: function (vType, vName) {
            return compare(vType, 'audio.*') && (compare(vType, /(ogg|mp3|mp?g|wav)$/i) ||
                compare(vName, /\.(og?|mp3|mp?g|wav)$/i));
        },
        flash: function (vType, vName) {
            return compare(vType, 'application/x-shockwave-flash', true) || compare(vName, /\.(swf)$/i);
        },
        pdf: function (vType, vName) {
            return compare(vType, 'application/pdf', true) || compare(vName, /\.(pdf)$/i);
        },
        object: function () {
            return true;
        },
        other: function () {
            return true;
        }
    };
    FileInput = function (element, options) {
        var self = this;
        self.$element = $(element);
        if (!self._validate()) {
            return;
        }
        self.isPreviewable = hasFileAPISupport();
        if (self.isPreviewable) {
            self._init(options);
            self._listen();
        } else {
            self.$element.removeClass('file-loading');
        }
    };
    FileInput.prototype = {
        constructor: FileInput,
        _init: function (options) {
            var self = this, $el = self.$element;
            $.each(options, function (key, value) {
                switch (key) {
                    case 'minFileCount':
                    case 'maxFileCount':
                    case 'maxFileSize':
                        self[key] = getNum(value);
                        break;
                    default:
                        self[key] = value;
                        break;
                }
            });
            if (isEmpty(self.allowedPreviewTypes)) {
                self.allowedPreviewTypes = defaultPreviewTypes;
            }
            self.fileInputCleared = false;
            self.fileBatchCompleted = true;
            if (!self.isPreviewable) {
                self.showPreview = false;
            }
            self.uploadFileAttr = !isEmpty($el.attr('name')) ? $el.attr('name') : 'file_data';
            self.reader = null;
            self.formdata = {};
            self.clearStack();
            self.uploadCount = 0;
            self.uploadLog = [];
            self.uploadAsyncCount = 0;
            self.loadedImages = [];
            self.totalImagesCount = 0;
            self.ajaxRequests = [];
            self.isError = false;
            self.ajaxAborted = false;
            self.dropZoneEnabled = hasDragDropSupport() && self.dropZoneEnabled;
            self.isUploadable = hasFileUploadSupport() && !isEmpty(self.uploadUrl);
            self.mainTemplate = self._getLayoutTemplate('main');
            self.previewGenericTemplate = self._getPreviewTemplate('generic');
          
            if (isEmpty(self.$element.attr('id'))) {
                self.$element.attr('id', uniqId());
            }
            if (self.$container === undefined) {
                self.$container = self._createContainer();
            }
            if (self.$wrapper === undefined) {
                self.$wrapper = self._createWrapper();
            }
            self.$preview = getElement(options, 'elPreviewContainer', self.$container.find('.file-preview'));
            self.previewInitId = "preview-" + uniqId();
            self.id = self.$element.attr('id');
            previewCache.init(self);
            self._initPreview(true);
            self.options = options;
            self.$element.removeClass('file-loading');
            self._initZoom();
            self._initLoading();
            if(self.uploadAuto){
                self.$element.on("filebatchselected", function(event, files) {
                    $(this).fileinput("upload");
                })
            }
            //self._readFiles(self.fileList);
            for (var i = 0; i < self.fileList.length; i += 1) {
                var file = self.fileList[i];
                self.filestack.push(file)
                self._loadFile(file);
                self._initFileActions();
            }
        },
        _validate: function () {
            var self = this, $exception;
            if (self.$element.attr('type') === 'file') {
                return true;
            }
            $exception = 
                '<div class="help-block alert alert-warning">' +
                '  <h4>Invalid Input Type</h4>' +
                '  You must set an input <code>type = file</code> for <b>bootstrap-fileinput</b> plugin to initialize.' +
                '</div>';
            self.$element.after($exception);
            return false;
        },
        _parseFileType: function (file) {
            var self = this, isValid, vType, cat, i;
            for (i = 0; i < defaultPreviewTypes.length; i += 1) {
                cat = defaultPreviewTypes[i];
                isValid = ifSet(cat, self.fileTypeSettings, defaultFileTypeSettings[cat]);
                vType = isValid(file.type, file.name) ? cat : '';
                if (!isEmpty(vType)) {
                    return vType;
                }
            }
            return 'other';
        },
        _raise: function (event, params) {
            var self = this, e = $.Event(event);
            if (params !== undefined) {
                self.$element.trigger(e, params);
            } else {
                self.$element.trigger(e);
            }
            if (e.isDefaultPrevented()) {
                return false;
            }
            if (!e.result) {
                return e.result;
            }
            switch (event) {
                // ignore these events
                case 'filebatchuploadcomplete':
                case 'filebatchuploadsuccess':
                case 'fileuploaded':
                case 'fileclear':
                case 'filecleared':
                case 'filereset':
                case 'fileerror':
                case 'filefoldererror':
                case 'fileuploaderror':
                case 'filebatchuploaderror':
                case 'filedeleteerror':
                case 'filecustomerror':
                case 'filesuccessremove':
                    break;
                // receive data response via `filecustomerror` event`
                default:
                    self.ajaxAborted = e.result;
                    break;
            }
            return true;
        },
        _listen: function () {
            var self = this, $el = self.$element;
            handler($el, 'change', $.proxy(self._change, self));
        },
        _initPreview: function (isInit) {
            var self = this, out;
            out = previewCache.out(self.id);
            self.$preview.html(out.content);
        },
        _getZoomButton: function (type) {
            var self = this, label = self.previewZoomButtonIcons[type], css = self.previewZoomButtonClasses[type],
                title = ' title="' + (self.previewZoomButtonTitles[type] || '') + '" ',
                params = title + 
                    (type === 'close' ? ' data-dismiss="modal" aria-hidden="true"' : '') + 
                    (type === 'remove' ? ' data-dismiss="modal"' : '');
            return '<button type="button" class="' + css + ' btn-' + type + '"' + params + '>' + label + '</button>';
        },
        _getModalContent: function () {
            var self = this;
            return self._getLayoutTemplate('modal')
                .replace(/\{prev}/g, self._getZoomButton('prev'))
                .replace(/\{next}/g, self._getZoomButton('next'))
                .replace(/\{remove}/g, self._getZoomButton('remove'))
                .replace(/\{close}/g, self._getZoomButton('close'));
        },
        _getLoading: function () {
        	var self = this;
        	return self._getLayoutTemplate('loading');
        },
        _initZoom: function () {
            var self = this, $dialog, modalMain = self._getLayoutTemplate('modalMain'), modalId = '#' + MODAL_ID;
            self.$modal = $(modalId);
            if (!self.$modal || !self.$modal.length) {
                $dialog = $(document.createElement('div')).html(modalMain).appendTo($("body"));
                self.$modal = $('#' + MODAL_ID).insertBefore($dialog);
                $dialog.remove();
            }
            self.$modal.html(self._getModalContent());
        },
        _initLoading: function () {
            var self = this, $loading, modalLoading = self._getLayoutTemplate('loadingMain'), loadingId = '#' + LOADING_ID;
            if (!self.$loading || self.$loading.length < 1) {
            	$loading = $(modalLoading).appendTo($("body"));
            }
            self.$loading = $(loadingId);
            self.$loading.html(self._getLoading());
            self.$loading.find(".load-text").css("width",$(document).width()).css("line-height", $(document).height());
        },
        _initZoomButtons: function () {
            var self = this, previewId = self.$modal.data('previewId') || '', $first, $last,
                fileItems = self.$preview.find('.file-item').toArray(), len = fileItems.length,
                $prev = self.$modal.find('.btn-prev'), $next = self.$modal.find('.btn-next');
            if (!len) {
                return;
            }
            if(len === 1 ){
                $prev.remove();
                $next.remove();
            }
            $first = $(fileItems[0]);
            $last = $(fileItems[len - 1]);
            $prev.removeAttr('disabled');
            $next.removeAttr('disabled');
            if ($first.length && $first.attr('id') === previewId) {
                $prev.attr('disabled', true);
            }
            if ($last.length && $last.attr('id') === previewId) {
                $next.attr('disabled', true);
            }
        },
        _zoomPreview: function ($fileItem) {
            var self = this
            if ($fileItem.children().length < 1) {
                throw 'No content! Can not zoom to detailed preview!';
            }
            self.$modal.html(self._getModalContent());
            self._setZoomContent($fileItem);
            self.$modal.modal('show');
            self._initZoomButtons();
        },
        _setZoomContent: function ($fileItem, animate) {
            var self = this, fname, tmplt, fileContent, $body, $dataEl, config, $tmp,
                previewId = $fileItem.attr('id'),
                $modal = self.$modal, 
                $prev = $modal.find('.btn-prev'), 
                $next = $modal.find('.btn-next'), 
                $btnRemove = $modal.find('.btn-remove');
            fname = $fileItem.data('filename') || '';
            tmplt = $fileItem.data('template') || 'generic';
            fileContent = $fileItem.children().length ? $fileItem.html() : '';
            $modal.find('.kv-zoom-title').html(fname);
            $body = $modal.find('.kv-zoom-body');
            if (animate) {
                $tmp = $body.clone().insertAfter($body);
                $body.html(fileContent).hide();
                $tmp.fadeOut('fast', function () {
                    $body.fadeIn('fast');
                    $tmp.remove();
                });
            } else {
                $body.html(fileContent);
            }
            config = self.previewZoomSettings[tmplt];
            if (config) {
                $dataEl = $body.find('.kv-preview-data');
                addCss($dataEl, 'file-zoom-detail');
                $.each(config, function (key, value) {
                    //$dataEl.css(key, value);
                    if (($dataEl.attr('width') && key === 'width') || ($dataEl.attr('height') && key === 'height')) {
                        $dataEl.removeAttr(key);
                    }
                });
                //这块简单做了  强制取屏幕的高度和宽度
                console.log(tmplt);
                $dataEl.css("width", $(document).width());
                $dataEl.css("height", $(document).height());
                if(tmplt != "image"){
                    $dataEl.css("padding-top", $(document).height()/2 - 10);
                    $dataEl.css("padding-left", "60px");
                }
            }
            $modal.data('previewId', previewId);
            handler($prev, 'click', function () {
                self._zoomSlideShow('prev', previewId);
            });
            handler($next, 'click', function () {
                self._zoomSlideShow('next', previewId);
            });
            handler($btnRemove, 'click', function () {
                self._removeFile(previewId);
            });
        },
        _zoomSlideShow: function (dir, previewId) {
            var self = this, $btn = self.$modal.find('.btn-' + dir), $targFileItem, i,
                fileItems = self.$preview.find('.file-item').toArray(), len = fileItems.length, out;
            if ($btn.attr('disabled')) {
                return;
            }
            for (i = 0; i < len; i++) {
                if ($(fileItems[i]).attr('id') === previewId) {
                    out = dir === 'prev' ? i - 1 : i + 1;
                    break;
                }
            }
            if (out < 0 || out >= len || !fileItems[out]) {
                return;
            }
            $targFileItem = $(fileItems[out]);
            if ($targFileItem.length) {
                self._setZoomContent($targFileItem, true);
            }
            self._initZoomButtons();
            self._raise('filezoom' + dir, {'previewId': previewId, modal: self.$modal});
        },
        _removeFile : function (previewId){
            var self = this, $fileItem = $("#" + previewId), removeUrl = $fileItem.data("remove-url");
            var remove = function (){
                $fileItem.remove();
                if(self.maxFileCount > self.$preview.find('.file-item').length){
                    self.$wrapper.removeClass("hidden");
                }
            };
            if(!isEmpty(removeUrl)){
                var jqXHR = $.ajax({
                    type : "delete",
                    url : removeUrl
                });
                jqXHR.done(function(data, textStatus, jqXHR) {
                    remove();
                });
                jqXHR.fail(function(textStatus, errorThrown) {
                    Toastr.warning(textStatus.responseText);
                    return;
                });
            }else{
                remove();
            }
        },
        _initFileActions: function () {
            var self = this;
            if (!self.showPreview) {
                return;
            }
            self.$preview.find('.file-item').each(function (i) {
                var $fileItem = $(this);
                handler($fileItem, 'click', function () {
                    self._zoomPreview($fileItem);
                });
            });
        },
        _generatePreviewTemplate: function (cat, data, fname, ftype, previewId, isError, size, frameClass, foot, ind, removeUrl) {
            var self = this, tmplt = self._getPreviewTemplate(cat), content, sText, css = frameClass || '',
                config = ifSet(cat, self.previewSettings, defaultPreviewSettings[cat]);
            ind = ind || previewId.slice(previewId.lastIndexOf('-') + 1);
                content = tmplt.replace(/\{previewId}/g, previewId)
                    .replace(/\{width}/g, config.width)
                    .replace(/\{height}/g, config.height)
                    .replace(/\{frameClass}/g, css)
                    .replace(/\{type}/g, ftype)
                    .replace(/\{fileindex}/g, ind)
                    .replace(/\{filename}/g, fname)
                    .replace(/\{removeUrl}/g, removeUrl)
                    .replace(/\{data}/g, ftype.indexOf("image") >= 0 ? data : fname)
                    .replace(/\{template}/g, cat);
            return content;
        },
        _previewDefault: function (file, previewId) {
            var self = this, $preview = self.$preview, $previewLive = $preview.find('.rows');
            if (!self.showPreview) {
                return;
            }
            var fname = file ? file.name : '', ftype = file ? file.type : '', content,
                isError = isDisabled === true && !self.isUploadable, data = objUrl.createObjectURL(file);
            if (!$previewLive.length) {
                $previewLive = $(document.createElement('div')).addClass('rows').appendTo($preview);
            }
            content = self._generatePreviewTemplate('other', data, fname, ftype, previewId, isError, file.size, null,null,null, file.removeUrl);
            $previewLive.append("\n" + content);
            $previewLive.find("#" + previewId).append(self.$element.clone().attr("id","1").addClass("hidden"));
            self.$element.val("");
        },
        _previewFile: function (i, file, theFile, previewId, data) {
            if (!this.showPreview) {
                return;
            }
            var self = this, cat = self._parseFileType(file), fname = file ? file.name : '',
                types = self.allowedPreviewTypes, mimes = self.allowedPreviewMimeTypes, $preview = self.$preview,
                chkTypes = types && types.indexOf(cat) >= 0, $previewLive = $preview.find('.rows'),
                iData = (cat === 'text' || cat === 'html' || cat === 'image') ? theFile.target.result : data, content,
                chkMimes = mimes && mimes.indexOf(file.type) !== -1;
            if (!$previewLive.length) {
                $previewLive = $(document.createElement('div')).addClass('rows').appendTo($preview);
            }
            /** @namespace window.DOMPurify */
            if (cat === 'html' && self.purifyHtml && window.DOMPurify) {
                iData = window.DOMPurify.sanitize(iData);
            }
            if (chkTypes || chkMimes) {
                content = self._generatePreviewTemplate(cat, iData, fname, file.type, previewId, false, file.size, null,null,null, file.removeUrl);
                $previewLive.append("\n" + content);
            } else {
                self._previewDefault(file, previewId);
            }
        },
        _loadFile : function (file){
            var self = this, cat = self._parseFileType(file), fname = file ? file.name : '',
                $previewLive = self.$preview.find('.rows'), content,
                previewId = self.previewInitId + "-" + (self.filestack.length-1);
            if (!$previewLive.length) {
                $previewLive = $(document.createElement('div')).addClass('rows').appendTo(self.$preview);
            }
            content = self._generatePreviewTemplate(cat, file.url, fname, file.type, previewId, false, file.size, null,null,null, file.removeUrl);
            $previewLive.append("\n" + content);
            if(self.$preview.find(".file-item").length + 1 >= self.maxFileCount){
                self.$wrapper.addClass("hidden");
            }
        },
        _readFiles: function (files) {
            this.reader = new FileReader();
            var self = this,
                $el = self.$element, $preview = self.$preview, reader = self.reader,
                $container = self.$preview, msgLoading = self.msgLoading,
                msgProgress = self.msgProgress, previewInitId = self.previewInitId, numFiles = files.length,
                settings = self.fileTypeSettings, ctr = self.filestack.length, readFile,
                maxPreviewSize = self.maxFilePreviewSize && parseFloat(self.maxFilePreviewSize),
                canPreview = $preview.length && (!maxPreviewSize || isNaN(maxPreviewSize));
            self.loadedImages = [];
            self.totalImagesCount = 0;

            $.each(files, function (key, file) {
                var func = self.fileTypeSettings.image || defaultFileTypeSettings.image;
                if (func && func(file.type)) {
                    self.totalImagesCount++;
                }
            });
            readFile = function (i) {
                if (isEmpty($el.attr('multiple'))) {
                    numFiles = 1;
                }
                if (i >= numFiles) {
                    if (self.isUploadable && self.filestack.length > 0) {
                        self._raise('filebatchselected', [self.getFileStack()]);
                    } else {
                        self._raise('filebatchselected', [files]);
                    }
                    $container.removeClass('file-thumb-loading');
                    return;
                }
                var node = ctr + i, previewId = previewInitId + "-" + node, isText, isImage, file = files[i],
                     fileSize = (file.size || 0) / 1000, checkFile, fileExtExpr = '',
                    previewData = objUrl.createObjectURL(file), fileCount = 0, j, msg, typ, chk,
                    fileTypes = self.allowedFileTypes, strTypes = isEmpty(fileTypes) ? '' : fileTypes.join(', '),
                    fileExt = self.allowedFileExtensions, strExt = isEmpty(fileExt) ? '' : fileExt.join(', ');
                if (fileSize > maxPreviewSize) {
                    Toastr.warning("最大只允许上传50MB的文件！");
                    return;
                }
                if (!isEmpty(fileExt)) {
                    fileExtExpr = new RegExp('\\.(' + fileExt.join('|') + ')$', 'i');
                }
                fileSize = fileSize.toFixed(2);
                if (self.maxFileSize > 0 && fileSize > self.maxFileSize) {
                    msg = self.msgSizeTooLarge
                        .replace('{size}', fileSize)
                        .replace('{maxSize}', self.maxFileSize);
                    self.isError = throwError(msg, file, previewId, i);
                    return;
                }
                if (!isEmpty(fileTypes) && isArray(fileTypes)) {
                    for (j = 0; j < fileTypes.length; j += 1) {
                        typ = fileTypes[j];
                        checkFile = settings[typ];
                        chk = (checkFile !== undefined);
                        fileCount += isEmpty(chk) ? 0 : chk.length;
                    }
                    if (fileCount === 0) {
                        msg = self.msgInvalidFileType.replace('{types}', strTypes);
                        self.isError = throwError(msg, file, previewId, i);
                        return;
                    }
                }
                if (fileCount === 0 && !isEmpty(fileExt) && isArray(fileExt) && !isEmpty(fileExtExpr)) {
                    fileCount += isEmpty(chk) ? 0 : chk.length;
                    if (fileCount === 0) {
                        msg = self.msgInvalidFileExtension.replace('{extensions}',
                            strExt);
                        self.isError = throwError(msg, file, previewId, i);
                        return;
                    }
                }
                if (!self.showPreview) {
                    self.addToStack(file);
                    setTimeout(function () {
                        readFile(i + 1);
                    }, 100);
                    self._raise('fileloaded', [file, previewId, i, reader]);
                    return;
                }
                if (!canPreview && fileSize > maxPreviewSize) {
                    $container.addClass('file-thumb-loading');
                    self._previewDefault(file, previewId);
                    self._initFileActions();
                    self._updateFileDetails(numFiles);
                    readFile(i + 1);
                    return;
                }
                if($preview.find(".file-item").length + 1 >= self.maxFileCount){
                    self.$wrapper.addClass("hidden");
                }
                if ($preview.length && FileReader !== undefined) {
                    $container.addClass('file-thumb-loading');
                    reader.onload = function (theFile) {
                        self._previewFile(i, file, theFile, previewId, previewData);
                        self._initFileActions();
                        //self._uploadFile();
                    };
                    reader.onloadend = function () {
                        msg = msgProgress.replace('{index}', i + 1).replace('{files}', numFiles)
                            .replace('{percent}', 50);
                        setTimeout(function () {
                            self._updateFileDetails(numFiles);
                            readFile(i + 1);
                        }, 100);
                        self._raise('fileloaded', [file, previewId, i, reader]);
                    };
                    reader.onprogress = function (data) {
                        if (data.lengthComputable) {
                            var fact = (data.loaded / data.total) * 100, progress = Math.ceil(fact);
                            msg = msgProgress.replace('{index}', i + 1).replace('{files}', numFiles)
                                .replace('{percent}', progress);
                            setTimeout(function () {
                            }, 100);
                        }
                    };
                    isText = ifSet('text', settings, defaultFileTypeSettings.text);
                    isImage = ifSet('image', settings, defaultFileTypeSettings.image);

                    if (isText(file.type)) {
                        reader.readAsText(file, self.textEncoding);
                    } else {
                        if (isImage(file.type)) {
                            reader.readAsDataURL(file);
                        } else {
                            reader.readAsArrayBuffer(file);
                        }
                    }
                } else {
                    self._previewDefault(file, previewId);
                    setTimeout(function () {
                        readFile(i + 1);
                        self._updateFileDetails(numFiles);
                    }, 100);
                    self._raise('fileloaded', [file, previewId, i, reader]);
                }
                self.addToStack(file);
            };

            readFile(0);
            self._updateFileDetails(numFiles, false);
        },
        _updateFileDetails: function (numFiles) {
            var self = this, $el = self.$element, fileStack = self.getFileStack(),
                name = findFileName($el.val()) ||
                    ($el[0].files[0] && $el[0].files[0].name) || (fileStack.length && fileStack[0].name) || '',
                 n = self.isUploadable ? fileStack.length : numFiles;
            if (self.isError) {
                self.$preview.removeClass('file-thumb-loading');
            }
            if (arguments.length === 1) {
                self._raise('fileselect', [numFiles]);
            }
        },
        _getFileCount: function (fileCount) {
            var self = this, addCount = 0;
            if (self.validateInitialCount && !self.overwriteInitial) {
                addCount = previewCache.count(self.id);
                fileCount += addCount;
            }
            return fileCount;
        },
        _createContainer: function () {
            var self = this;
            var $container = $(document.createElement("div")).addClass("file-input");
            if(self.fullWidth) $container.addClass("clearfix");
            self.$element.wrap($container).before(self._renderMain());
            return self.$element.parent();
        },
        _createWrapper: function () {
            var self = this;
            var one_third = self.$container.width()/3 - 20;
            var $btnFileContainer = $('<div class="file-wrapper"></div>').addClass("col-xs-4");
            $btnFileContainer.css("height", one_third + 10);
            var $btnIcon = $('<div class="file-icon"></div>');
            $btnIcon.css("width", "100%").css("height", one_third).css("bottom", one_third);
            self.$element.wrap($btnFileContainer);
            self.$element.after($btnIcon);
            return self.$element.parent(".file-wrapper");
        },
        _renderMain: function () {
            var self = this,
                preview = !self.showPreview ? '' : self._getLayoutTemplate('preview')
                    .replace(/\{class}/g, self.previewClass);
            return self.mainTemplate.replace(/\{class}/g, self.mainClass)
                .replace(/\{preview}/g, preview);
        },
        _change: function (e) {
            var self = this, $el = self.$element;
            self.$loading.modal('show');
            if (!self.isUploadable && isEmpty($el.val()) && self.fileInputCleared) { // IE 11 fix
                self.fileInputCleared = false;
                return;
            }
            self.fileInputCleared = false;
            var tfiles, msg, total, isDragDrop = arguments.length > 1, i = 0, f, n, len,
                files = isDragDrop ? e.originalEvent.dataTransfer.files : $el.get(0).files,
                folders = 0;
            self.reader = null;
            if (isDragDrop) {
                tfiles = [];
                while (files[i]) {
                    f = files[i];
                    if (!f.type && f.size % 4096 === 0) {
                        folders++;
                    } else {
                        tfiles.push(f);
                    }
                    i++;
                }
            } else {
                if (e.target.files === undefined) {
                    tfiles = e.target && e.target.value ? [
                        {name: e.target.value.replace(/^.+\\/, '')}
                    ] : [];
                } else {
                    tfiles = e.target.files;
                }
            }
            if (isEmpty(tfiles) || tfiles.length === 0) {
                self._raise('fileselectnone');
                return;
            }
            /*len = tfiles.length;
            total = self._getFileCount(self.isUploadable ? (self.getFileStack().length + len) : len);
            if (self.maxFileCount > 0 && total > self.maxFileCount) {
                if (!self.autoReplace || len > self.maxFileCount) {
                    n = (self.autoReplace && len > self.maxFileCount) ? len : total;
                    msg = self.msgFilesTooMany.replace('{m}', self.maxFileCount).replace('{n}', n);
                    self.isError = throwError(msg, null, null, null);
                    return;
                }
            }*/
            if (self.isPreviewable) {
                self._readFiles(tfiles);
            } else {
                self._updateFileDetails(1);
            }
        },
        _getLayoutTemplate: function (t) {
            var self = this,
                template = ifSet(t, self.layoutTemplates, defaultLayoutTemplates[t]);
            if (isEmpty(self.customLayoutTags)) {
                return template;
            }
            return replaceTags(template, self.customLayoutTags);
        },
        _getPreviewTemplate: function (t) {
            //把除了图片之外的文件全部用text显示, 内容显示
            t = t == "image" ?  t : "text";
            var self = this,
                template = ifSet(t, self.previewTemplates, defaultPreviewTemplates[t]);
            if (isEmpty(self.customPreviewTags)) {
                return template;
            }
            return replaceTags(template, self.customPreviewTags);
        },
        _getFileName: function (file) {
            return file && file.name ? file.name : undefined;
        },
        clearStack: function () {
            var self = this;
            self.filestack = [];
            self.filenames = [];
            return self.$element;
        },
        updateStack: function (i, file) {
            var self = this;
            self.filestack[i] = file;
            self.filenames[i] = self._getFileName(file);
            return self.$element;
        },
        addToStack: function (file) {
            var self = this;
            self.filestack.push(file);
            self.filenames.push(self._getFileName(file));
            return self.$element;
        },
        getFileStack: function (skipNull) {
            var self = this;
            return self.filestack.filter(function (n) {
                return (skipNull ? n !== undefined : n !== undefined && n !== null);
            });
        },
        _getExtraData: function (previewId, index) {
            var self = this, data = self.uploadExtraData;
            if (typeof self.uploadExtraData === "function") {
                data = self.uploadExtraData(previewId, index);
            }
            return data;
        },
        _getOutData: function (jqXHR, responseData, filesData) {
            var self = this;
            jqXHR = jqXHR || {};
            responseData = responseData || {};
            filesData = filesData || self.filestack.slice(0) || {};
            return {
                form: self.formdata,
                files: filesData,
                filenames: self.filenames,
                extra: self._getExtraData(),
                response: responseData,
                reader: self.reader,
                jqXHR: jqXHR
            };
        },
        _resetUpload: function () {
            var self = this;
            self.uploadCache = {content: [], config: [], tags: [], append: true};
            self.uploadCount = 0;
            self.uploadStatus = {};
            self.uploadLog = [];
            self.uploadAsyncCount = 0;
            self.loadedImages = [];
            self.totalImagesCount = 0;
            self.ajaxAborted = false;
            self.ajaxRequests = [];
        },
        _abort: function (params) {
            var self = this, data;
            if (self.ajaxAborted && typeof self.ajaxAborted === "object" && self.ajaxAborted.message !== undefined) {
                data = $.extend(true, {}, self._getOutData(), params);
                data.abortData = self.ajaxAborted.data || {};
                data.abortMessage = self.ajaxAborted.message;
                self.cancel();
                self._setProgress(100, self.$progress, self.msgCancelled);
                self._showUploadError(self.ajaxAborted.message, data, 'filecustomerror');
                return true;
            }
            return false;
        },
        _ajaxSubmit: function (fnBefore, fnSuccess, fnComplete, fnError, previewId, index) {
            var self = this, settings;
            self._raise('filepreajax', [previewId, index]);
            self._uploadExtra(previewId, index);
            settings = $.extend(true, {}, {
                url: self.uploadUrl,
                type: 'POST',
                dataType: 'json',
                data: self.formdata,
                cache: false,
                processData: false,
                contentType: false,
                beforeSend: fnBefore,
                success: fnSuccess,
                complete: fnComplete,
                error: fnError
            }, self.ajaxSettings);
            self.ajaxRequests.push($.ajax(settings));
        },
        _uploadExtra: function (previewId, index) {
            var self = this, data = self._getExtraData(previewId, index);
            if (data.length === 0) {
                return;
            }
            $.each(data, function (key, value) {
                self.formdata.append(key, value);
            });
        },
        _uploadBatch: function () {
            var self = this, files = self.filestack, total = files.length, params = {}, fnBefore, fnSuccess, fnError,
                fnComplete, hasPostData = self.filestack.length > 0 || !$.isEmptyObject(self.uploadExtraData),
                setAllUploaded;
            self.formdata = new FormData();
            if (total === 0 || !hasPostData || self._abort(params)) {
                return;
            }
            setAllUploaded = function () {
                $.each(files, function (key) {
                    self.updateStack(key, undefined);
                });
                self._clearFileInput();
            };
            fnBefore = function (jqXHR) {
                var outData = self._getOutData(jqXHR);
                self._raise('filebatchpreupload', [outData]);
                if (self._abort(outData)) {
                    jqXHR.abort();
                    self._setProgressCancelled();
                }
            };
            fnSuccess = function (data, textStatus, jqXHR) {
            	self.$loading.modal('hide');
            };
            fnComplete = function () {
                self._raise('filebatchuploadcomplete', [self.filestack, self._getExtraData()]);
                self.$loading.modal('hide');
            };
            fnError = function (jqXHR, textStatus, errorThrown) {
            	self.$loading.modal('hide');
            };
            $.each(files, function (key, data) {
                if (!isEmpty(files[key])) {
                    self.formdata.append(self.uploadFileAttr, data, self.filenames[key]);
                }
            });
            self._ajaxSubmit(fnBefore, fnSuccess, fnComplete, fnError);
        },
        _uploadSingle: function (i, files, allFiles) {
            var self = this, total = self.getFileStack().length, formdata = new FormData(), outData,
                previewId = self.previewInitId + "-" + i, $thumb, chkComplete, $btnUpload, $btnDelete,
                hasPostData = self.filestack.length > 0 || !$.isEmptyObject(self.uploadExtraData),
                fnBefore, fnSuccess, fnComplete, fnError, updateUploadLog, params = {id: previewId, index: i};
            self.formdata = formdata;
            if (self.showPreview) {
                $thumb = $('#' + previewId + ':not(.file-preview-initial)');
                $btnUpload = $thumb.find('.kv-file-upload');
                $btnDelete = $thumb.find('.kv-file-remove');
                $('#' + previewId).find('.file-thumb-progress').removeClass('hide');
            }
            if (total === 0 || !hasPostData || ($btnUpload && $btnUpload.hasClass('disabled')) || self._abort(params)) {
                return;
            }
            updateUploadLog = function (i, previewId) {
                self.updateStack(i, undefined);
                self.uploadLog.push(previewId);
                if (self._checkAsyncComplete()) {
                    self.fileBatchCompleted = true;
                }
            };
            chkComplete = function () {
                var u = self.uploadCache;
                if (!self.fileBatchCompleted) {
                    return;
                }
                setTimeout(function () {
                    if (self.showPreview) {
                        previewCache.set(self.id, u.content, u.config, u.tags, u.append);
                        if (self.hasInitData) {
                            self._initPreview();
                            self._initPreviewActions();
                        }
                    }
                    self._raise('filebatchuploadcomplete', [self.filestack, self._getExtraData()]);
                    self.uploadCount = 0;
                    self.uploadStatus = {};
                    self.uploadLog = [];
                }, 100);
            };
            fnBefore = function (jqXHR) {
                 var outData = self._getOutData(jqXHR);
                 self._raise('filebatchpreupload', [outData]);
            };
            fnSuccess = function (data, textStatus, jqXHR) {
                var $item = self.$preview.find("#" + previewId);
                var removeUrl = jqXHR.getResponseHeader("removeUrl");
                $item.data("remove-url", removeUrl);
                Toastr.success("上传成功");
            };
            fnComplete = function () {
            	self.$loading.modal('hide');
                setTimeout(function () {
                    if (self.showPreview) {
                        $btnUpload.removeAttr('disabled');
                        $btnDelete.removeAttr('disabled');
                        $thumb.removeClass('file-uploading');
                    }
                    if (!allFiles) {
                        self.unlock(false);
                        self._clearFileInput();
                    } else {
                        chkComplete();
                    }
                }, 100);
            };
            fnError = function (jqXHR, textStatus, errorThrown) {
            	self.$container.find(".file-item:last").remove();
            	Toastr.warning("上传失败");
            	
            };
            formdata.append(self.uploadFileAttr, files[i], files[i].name);
            formdata.append('file_id', i);
            if(!isEmpty(files[i].params)){
                $.each(files[i].params, function (key, value) {
                    self.formdata.append(key, value);
                });
            }
            self._ajaxSubmit(fnBefore, fnSuccess, fnComplete, fnError, previewId, i);
        },
        upload: function () {
            var self = this, totLen = self.getFileStack().length, params = {},
                i, outData, len, hasExtraData = !$.isEmptyObject(self._getExtraData());
            if (self.minFileCount > 0 && self._getFileCount(totLen) < self.minFileCount) {
                self._noFilesError(params);
                return;
            }
            if (!self.isUploadable || self.isDisabled || (totLen === 0 && !hasExtraData)) {
                return;
            }
            self._resetUpload();
            self.uploadCount = 0;
            self.uploadStatus = {};
            self.uploadLog = [];
            if (totLen === 0 && hasExtraData) {
                self._uploadExtraOnly();
                return;
            }
            len = self.filestack.length;
            self.hasInitData = false;
            if (self.uploadAsync) {
                outData = self._getOutData();
                self._raise('filebatchpreupload', [outData]);
                self.fileBatchCompleted = false;
                self.uploadCache = {content: [], config: [], tags: [], append: true};
                self.uploadAsyncCount = self.getFileStack().length;
                for (i = 0; i < len; i++) {
                    self.uploadCache.content[i] = null;
                    self.uploadCache.config[i] = null;
                    self.uploadCache.tags[i] = null;
                }
                for (i = 0; i < len; i++) {
                    if (self.filestack[i] !== undefined) {
                        self._uploadSingle(i, self.filestack, true);
                    }
                }
                return;
            }
            //self._uploadBatch();
            self._uploadSingle(len -1, self.filestack, true);
            return self.$element;
        }
    };

    $.fn.fileinput = function (option) {
        if (!hasFileAPISupport()) {
            return;
        }
        var args = Array.apply(null, arguments);
        var retvals = [];
        args.shift();
        this.each(function () {
            var self = $(this);
            var data = self.data('fileinput');
            var options = typeof option === 'object' && option;
            var opts;
            if (!data) {
                opts = $.extend(true, {}, $.fn.fileinput.defaults, options, $.fn.fileinputLocales,
                    self.data());
                data = new FileInput(this, opts);
                self.data('fileinput', data);
            }

            if (typeof option === 'string') {
                retvals.push(data[option].apply(data, args));
            }
        });
        switch (retvals.length) {
            case 0:
                return this;
            case 1:
                return retvals[0];
            default:
                return retvals;
        }
    };

    $.fn.fileinput.Constructor = FileInput;
    
    $.fn.fileinput.defaults = {
        uploadUrl : null,
        uploadAuto : true,
        uploadExtraData: {},
        autoUpload : false,
        showPreview: true,
        fullWidth : false,
        maxFileSize: 0,
        minFileCount: 0,
        maxFileCount : 9,
        maxFilePreviewSize: 51200,
        fileList: [],
        initialPreview: [],
        previewZoomButtonIcons: {
            prev: '<i class="glyphicon glyphicon-triangle-left"></i>',
            next: '<i class="glyphicon glyphicon-triangle-right"></i>',
            remove : '<i class="glyphicon glyphicon-trash"></i>',
            close: '<i class="glyphicon glyphicon-remove"></i>'
        },
        previewZoomButtonClasses: {
            prev: 'btn btn-navigate',
            next: 'btn btn-navigate',
            remove: 'btn btn-default',
            close: 'btn btn-default'
        },
        layoutTemplates: defaultLayoutTemplates,
        previewTemplates: defaultPreviewTemplates,
        previewZoomSettings: defaultPreviewZoomSettings,
        fileTypeSettings: defaultFileTypeSettings
    };
    
    $.fn.fileinputLocales = {
        msgProgress: '加载第 {index} 文件 共 {files} - {name} - {percent}% 完成.',
        previewZoomButtonTitles: {
            prev: '上一个文件',
            next: '下一个文件',
            remove : '删除该文件',
            close: '关闭'
        }
    };
}));